/* gbsp_6a.c
 * erzeugt Beispielmatrizen zum Aufgabenteil 6a
 * erstellt: Tue Nov  9 23:03:43 MET 1999
 * Autoren : Mirko Belickin und Joachim Wagner
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "matrix.h"
#include "nmmatrix.h"
#include "bandmtrx.h"


/* externe Klassenobjekte einbinden */

extern matrix band_matrix;
extern matrix nm_matrix;


/* Hauptprogramm 
 *
 * erzeugt Beispielmatrix vom Typ Aufgabe 06 mit
 *         a(i) = 4, b(i) = 1, c = 1  und 
 *         einen Vektor d mit d(i) = 2
 */

int main(int argc, char *argv[])
{
  FILE *out = stdout;
  FILE *temp;
  int hilfe = 0;        /* 1 = Hilfe fuer Benutzer anzeigen */   
  int fehler = 0;       /* 1 = Programm falsch aufgerufen */
  int schalter = 1;     /* 0 = es folgen keine Schalter ('--' gefunden) */
  int i, n;
  char tempname[80];

  nmmatrixschablone nmschablone;
  bandmatrixschablone bandschablone;
  matrix *a, *hilfsvektor;

  while ((schalter) && (argc>1) && (*argv[1]=='-')) {/* Schalter bearbeiten */
    switch ((argv[1])[1]) {
      case 'h': hilfe = 1;
                break;
      case '-': schalter = 0;
                break;
      default:  fprintf(stderr,"Schalter %s unbekannt.\n", argv[1]);
                fehler = 1;
                break;
    }
    argv[1] = argv[0];
    argv++; 
    argc--;
  }
  if ((argc>3) || (argc<2)) fehler = 1;
  if ((hilfe) || (fehler)) {             /* Hilfetext anzeigen */
    fprintf(stderr,"\nBenutzung: "
                   "%s [Schalter] [--] n [Ausgabedatei]\n\n",
                   argv[0]);
    fprintf(stderr,"Schalter: derzeit noch keine ausser -h fuer diese Hilfe\n");
    fprintf(stderr,"\nMirko Belickin und Joachim Wagner - 09. November 1999\n");
    exit(fehler);
  }
  if (argc>1) {
    n = atoi(argv[1]);
    if (n<2) {
      fprintf(stderr, "n muss mindestens 2 sein!\n");
      exit(1);
    }
  }
  if (argc>2) {
    if (!(temp=fopen(argv[2],"wb"))) {
      fprintf(stderr,"Oeffnen der Datei %s fehlgeschlagen.", argv[2]);
      exit(1);
    }
    out = temp;
  }

  bandschablone.n = n;
  bandschablone.m = 1;        /* Bandbreite 1 = Tridiagonalmatrix */
  sprintf(tempname, "Matrix A fuer Beispiel 6a mit n = %i", n);
  bandschablone.name = tempname;
  bandschablone.init = 0;
  
  a = band_matrix.aktion->kreieren(&bandschablone, NULL);

  hilfsvektor = a->aktion->imVektor(a,0);               /* Vektor a */
  for (i=1; i<=n; i++) 
    hilfsvektor->aktion->setzen(hilfsvektor, i, 1, 4);  /* a(i) = 4 */

  hilfsvektor = a->aktion->imVektor(a,1);               /* Vektor b */
  for (i=1; i<=(n-1); i++) 
    hilfsvektor->aktion->setzen(hilfsvektor, i, 1, 1);  /* b(i) = 1 */

  hilfsvektor = a->aktion->imVektor(a,2);               /* Vektor c */
  for (i=1; i<=(n-1); i++) 
    hilfsvektor->aktion->setzen(hilfsvektor, i, 1, 1);  /* c(i) = 1 */
  
  a->aktion->speichern(a, out);
  a->aktion->freigeben(a, NULL);

  /* Vektor d mit d(i) = 2 erzeugen */

  nmschablone.n = n;
  nmschablone.m = 1;
  sprintf(tempname, "Vektor d fuer Beispiel 6c mit n = %i", n);
  nmschablone.name = tempname;
  nmschablone.init = 0;

  a = nm_matrix.aktion->kreieren(&nmschablone, NULL);
  
  for (i=1; i<=n; i++) 
    a->aktion->setzen(a, i, 1, 2);
 
  a->aktion->speichern(a, out);
  a->aktion->freigeben(a, NULL);

  if (out != stdout) fclose(out);               /* Dateien ggf. schliessen */
  return 0;
}
