/* gbsp_c.c
 * erzeugt Beispielmatrizen zum Aufgabenteil c
 * erstellt: Don Okt 28 15:26:52 CEST 1999
 * Autoren : Mirko Belickin und Joachim Wagner
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "matrix.h"
#include "nmmatrix.h"


/* externes Klassenobjekt einbinden */

extern matrix nm_matrix;


/* Hauptprogramm 
 *
 * erzeugt Beispielmatrix mit a(i,j) = i ^ (j-1) und
 *         Vektor b mit b(i) = i
 */

int main(int argc, char *argv[])
{
  FILE *out = stdout;
  FILE *temp;
  int hilfe = 0;        /* 1 = Hilfe fuer Benutzer anzeigen */   
  int fehler = 0;       /* 1 = Programm falsch aufgerufen */
  int schalter = 1;     /* 0 = es folgen keine Schalter ('--' gefunden) */
  int i,j, n;

  nmmatrixschablone schablone;
  matrix *a; 

  while ((schalter) && (argc>1) && (*argv[1]=='-')) {/* Schalter bearbeiten */
    switch ((argv[1])[1]) {
      case 'h': hilfe = 1;
                break;
      case '-': schalter = 0;
                break;
      default:  fprintf(stderr,"Schalter %s unbekannt.\n", argv[1]);
                fehler = 1;
                break;
    }
    argv[1] = argv[0];
    argv++; 
    argc--;
  }
  if ((argc>3) || (argc<2)) fehler = 1;
  if ((hilfe) || (fehler)) {             /* Hilfetext anzeigen */
    fprintf(stderr,"\nBenutzung: "
                   "%s [Schalter] [--] n [Ausgabedatei]\n\n",
                   argv[0]);
    fprintf(stderr,"Schalter: derzeit noch keine ausser -h fuer diese Hilfe\n");
    fprintf(stderr,"\nMirko Belickin und Joachim Wagner - 28. Oktober 1999\n");
    exit(fehler);
  }
  if (argc>1) {
    n = atoi(argv[1]);
    if (n<1) {
      fprintf(stderr, "n muss mindestens 1 sein!\n");
      exit(1);
    }
  }
  if (argc>2) {
    if (!(temp=fopen(argv[2],"wb"))) {
      fprintf(stderr,"Oeffnen der Datei %s fehlgeschlagen.", argv[2]);
      exit(1);
    }
    out = temp;
  }

  schablone.n = n;
  schablone.m = n;
  schablone.init = 0;
  
  a = nm_matrix.aktion->kreieren(&schablone, NULL);

  for (i=1; i<=n; i++) {
    for (j=1; j<=n; j++) {
      a->aktion->setzen(a, i, j, pow(i, j-1));
    }
  }
 
  a->aktion->speichern(a, out);

  a->aktion->freigeben(a, NULL);


  /* Vektor b mit b(i) = i erzeugen */

  schablone.m = 1;

  a = nm_matrix.aktion->kreieren(&schablone, NULL);
  
  for (i=1; i<=n; i++) {
    a->aktion->setzen(a, i, 1, i);
  }
 
  a->aktion->speichern(a, out);

  a->aktion->freigeben(a, NULL);


  if (out != stdout) fclose(out);               /* Dateien ggf. schliessen */

  return 0;
}
